
table = (name) ->
  t = new Relation(table)

join = (rel1, rel2, opts={}) ->
  type = opts.type ? INNER
  clause = opts.clause
  new Join rel1, rel2, type, clause


where({'t1.timestamp': {gt: 2}}, select
  fields: ['t1.*', 't2.*']
  from: join(
    alias('t1', table('table1')),
    alias('t2', table('table2')),
    clause: 't1.x = t2.y'
    type: LEFT_OUTER
  )
.execute (err, res) ->
  null


table2 = [
  {a: 1, b: 2, c: 3}
  {a: 2, b: 3, c: 1}
  {a: 3, b: 1, c: 2}
]

table2 = table1.as('table2')

(insert 'table3',
  (where "table1.b > 2"
    (project "table1.a": "t1_a", "table2.b": "t1_b"
      (join table1, table1.as('table2'), "table1.c = table2.a"))))


self_join = join(table1, (table2 = table1.as('table2')), table1.eq(table2.a))
insert('table3', self_join.fields(table1.a.as('t1_a'), table2.b.as('t2_b')).where(b: gt: 2))

# INSERT INTO table3
#   SELECT table1.a AS t1_a, table2.b AS t1_b 
#   FROM table1 JOIN table2 AS table2 ON table1.c = table2.a
#   WHERE table1.b > 2;



